//+------------------------------------------------------------------+
//| MODIFIED BY AVERY T. HORTON, JR AKA THERUMPLEDONE                |
//|   
// FPI DEVELOPED MY MICHAL KRESLIK WWW.KRESLIK.COM                   |
//|           FPI  Fractional Product Inefficiency                  |
//|                                                          FPI.mq4 |
//|                                         Developed by Coders Guru |
//|                                            http://www.xpworx.com |
//+------------------------------------------------------------------+

#property link      "http://www.xpworx.com"
#property copyright "Coders' Guru" 


#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Yellow

extern bool   Send.Mail      = true ;
extern bool   Sound.Alert    = false ; 
extern bool   Show.Comment   = true ;

extern double myUpperThreshold = 1.001 ;
extern double myLowerThreshold = 0.999 ;
extern double mySensitivity = 0.001 ;

extern string myUpperAlert = "FPI UPPER ALERT" ;  
extern string myLowerAlert = "FPI LOWER ALERT" ;  


double Main[] , PAIR1[] ,PAIR2[] ,PAIR3[] ;

bool   AlertUpper,  AlertLower   ;
string symbol, tChartPeriod ;  

string pairs[14][3]={

"EURUSD","USDJPY","EURJPY",//14
"EURAUD","AUDJPY","EURJPY",//1 d
"EURCHF","CHFJPY","EURJPY",//6 h, inv

"GBPUSD","USDJPY","GBPJPY",//14
"GBPUSD","USDCHF","GBPCHF",//15

"EURGBP","GBPJPY","EURJPY",//12 inv

"AUDUSD","USDJPY","AUDJPY", //2 d

"EURUSD","EURGBP","GBPUSD",//13
"EURAUD","AUDUSD","EURUSD",//3 d


"USDCHF","CHFJPY","USDJPY",//8 



"GBPCHF","CHFJPY","GBPJPY",//7 inv

"EURUSD","USDCAD","EURCAD", //9 inv

"EURUSD","USDCHF","EURCHF",//11 inv

"EURGBP","GBPCHF","EURCHF", //10 inv






   
   
};


  string iPair1 ;
  string iPair2 ;
  string iPair3 ;  

   int match[];
   int c, f, g, z=0 ;
   
     string zPair ;
     bool pTest = false ;
     double MaxFPI = -9999, MinFPI = 9999, DiffFPI = 0 ;
     int    MaxBar, MinBar ;
   
//+------------------------------------------------------------------+
int init()
  {
   symbol       =  Symbol() ;

   SetLevelStyle(STYLE_DOT, 1, DimGray) ;
   SetLevelValue(1,1+mySensitivity*3);
   SetLevelValue(2,1+mySensitivity*2);   
   SetLevelValue(3,1+mySensitivity);
   SetLevelValue(4,1);
   SetLevelValue(5,1-mySensitivity);
   SetLevelValue(6,1-2*mySensitivity);
   SetLevelValue(7,1-3*mySensitivity);  
   
   
   IndicatorBuffers(4); 
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Main);
   
   SetIndexBuffer(1,PAIR1);
   SetIndexBuffer(2,PAIR2);
   SetIndexBuffer(3,PAIR3);

   ArrayInitialize(PAIR1,EMPTY_VALUE);
   ArrayInitialize(PAIR2,EMPTY_VALUE);
   ArrayInitialize(PAIR3,EMPTY_VALUE);
   ArrayInitialize(Main,EMPTY_VALUE);


   
    c=0;
   
   for(int i=0;i<14;i++)
   {
      for(int y=0;y<3;y++)
      {
 
         if(!pTest && pairs[i][y] == symbol )
         {
            c++;
            ArrayResize(match,c);
            match[c-1]=i; 
             pTest = true ;
             f = i ; g = y ; z=z+1 ; break ;
         }
      }
      if(pTest){break ; }
   }


   iPair1 = pairs[f][0] ;
   iPair2 = pairs[f][1] ;
   iPair3 = pairs[f][2] ;

   if(!pTest) {Comment( "\n ***ERROR: ", symbol, " not found in FPI list ", "\n",
   "pairs[9][1]  ", pairs[9][1] , "  f = ", f, "  g = ", g, "  zPair = ", zPair, "  Symbol() = ", Symbol()  
   , " pTest = ", pTest  , " z = ", z 
   , "\n FPI PAIRS: ", iPair1, " | ", iPair2, " | ", iPair3
   ) ; return(-1) ; } 
 

  MaxFPI = -9999;
  MinFPI = 9999 ;
  
   return(0);
  }

//+------------------------------------------------------------------+
int deinit()
  {
  if(Show.Comment) {Comment("") ;} 
  
   return(0);
  }

//+------------------------------------------------------------------+
int start()
  {
   int counted_bars;
   
   ArrayCopySeries(PAIR1,MODE_CLOSE,iPair1,Period());
   ArrayCopySeries(PAIR2,MODE_CLOSE,iPair2,Period());
   ArrayCopySeries(PAIR3,MODE_CLOSE,iPair3,Period());

   counted_bars = IndicatorCounted();
   
   int i = 0;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   
   for(i=0; i<limit; i++)
   {
       Main[i] = PAIR1[i]* PAIR2[i]* (1/PAIR3[i]);
       if( Main[i] < 3  && Main[i] > MaxFPI) { MaxFPI  = Main[i] ; MaxBar = i  ; }
       if( Main[i] > -3 && Main[i] < MinFPI) { MinFPI  = Main[i] ; MinBar = i  ; }       
   }

    DiffFPI = Main[0] - 1 ;
  
  AlertUpper = false ;
  AlertLower = false ;
  
  if( Main[0] <= myLowerThreshold && Main[1] >= myLowerThreshold ) { AlertLower = true ; } 
  if( Main[0] >= myUpperThreshold && Main[1] <= myUpperThreshold ) { AlertUpper = true ; } 

  if( Sound.Alert )
  {
    if( AlertUpper ) { Alert(symbol,"  ",  myUpperAlert + " " + DoubleToStr(Main[0] ,4)); }
    if( AlertLower ) { Alert(symbol,"  ",  myLowerAlert + " " + DoubleToStr(Main[0] ,4)); }     
  }
  
  if( Send.Mail )
  {
    if( AlertUpper ) { SendMail(symbol,  myUpperAlert) ; }
    if( AlertLower ) { SendMail(symbol,  myLowerAlert) ; }     
  }  

if(Show.Comment)
{
  Comment( "\n\n\n\n\n\n\n\n",
           "FPI PAIRS: ", iPair1, " | ", iPair2, " | ", iPair3, "\n",
           "FPI     = ", DoubleToStr(Main[0],5), "  FPI +/- = ", DoubleToStr(DiffFPI,5), "\n",           
           "Max FPI = ", DoubleToStr(MaxFPI,5), "  Bar# = ", MaxBar, "\n",
           "Min FPI = ", DoubleToStr(MinFPI,5), "  Bar# = ", MinBar, "\n",
           "Sensitivity = ", DoubleToStr(mySensitivity,5), "\n",  
           ""  ) ;    
}


return(0);
}


//+------------------------------------------------------------------+
/*

        if(i ==9 && y == 1) {   zPair = pairs[i][y] ;}
        
   iPair1 = pairs[match[i]][0] ;
   iPair2 = pairs[match[i]][1] ;
   iPair3 = pairs[match[i]][2] ;
   
*/