//+------------------------------------------------------------------+
//|MFI_TRO_MODIFIED_VERSION                     Money Flow Index.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
//| _TRO_MODIFIED_VERSION                                  |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+
 
 
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window

 
#property indicator_buffers 3
 
extern bool   Show.Commemt   = true ;

//---- input parameters
extern int ExtMFIPeriod  =14; 
extern int iNumBars      = 0 ;
extern int iMaxThreshold = 80 ;
extern int iMinThreshold = 20 ;

//---- buffers
double ExtMFIBuffer[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];

double minpips = 99999, maxpips = -99999 , spread, diff, maxdiff=-999, mindiff=999;

string  sSpread, sOpen, sPrice, sHigh, sLow, sPct, sMinDateTime, sMaxDateTime ; 
int      cd, cd1, cd2, BarsBack1, BarsBack2, minbar, maxbar ;


string symbol, tChartPeriod,  tShortName, trademsg ;   
  
int    digits2, digits, period, win, xInc, yInc, xPos, yPos  ;  
 
double    point , maxpct, minpct ;
int MaxThresholdCount = 0 ;
int MinThresholdCount = 0, BarsInStudy ;
  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
   period       =  Period() ;    
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ; 
  
   string sShortName;
//----
   SetIndexBuffer(0,ExtMFIBuffer);
//---- indicator line
   SetIndexStyle(0,DRAW_LINE, 0, 1, Blue );
//---- name for DataWindow and indicator subwindow label
   sShortName="MFI("+ExtMFIPeriod+")";
   IndicatorShortName(sShortName);
   SetIndexLabel(0,sShortName);
//---- first values aren't drawn
   SetIndexDrawBegin(0,ExtMFIPeriod);
//----
   
   SetIndexBuffer( 1, ExtMapBuffer2 );
   SetIndexBuffer( 2, ExtMapBuffer3 );
 
   SetIndexStyle( 1, DRAW_LINE, 0, 1, Green );
   SetIndexStyle( 2, DRAW_LINE, 0, 1, Red );
 


   SetLevelStyle(STYLE_DOT, 1, DimGray) ;
   SetLevelValue(1,95 );
   SetLevelValue(2,90 );   
   SetLevelValue(3,80 );
   SetLevelValue(4,50);
   SetLevelValue(5,20 );
   SetLevelValue(6,10 );
   SetLevelValue(7,5 ); 
   return(0);
  }
//+------------------------------------------------------------------+
//| Money Flow Index                                                 |
//+------------------------------------------------------------------+
int start()
  {
   int    i,j,nCountedBars;
   double dPositiveMF,dNegativeMF,dCurrentTP,dPreviousTP;
//---- insufficient data
   if(Bars<=ExtMFIPeriod) return(0);
//---- bars count that does not changed after last indicator launch.
   nCountedBars=IndicatorCounted();
//----
   i=Bars-ExtMFIPeriod-1;
   if(nCountedBars>ExtMFIPeriod) 
      i=Bars-nCountedBars-1;
      

maxdiff = -9999 ;
mindiff = 99999 ;      

MaxThresholdCount = 0 ;
MinThresholdCount = 0 ;
      
     
      
   if( iNumBars > 0 ) { i = iNumBars ; }  
    
   BarsInStudy =  i ; 
      
   while(i>=0)
     {
      dPositiveMF=0.0;
      dNegativeMF=0.0;
      dCurrentTP=(High[i]+Low[i]+Close[i])/3;
      for(j=0; j<ExtMFIPeriod; j++)
        {
         dPreviousTP=(High[i+j+1]+Low[i+j+1]+Close[i+j+1])/3;
         if(dCurrentTP>dPreviousTP)
            dPositiveMF+=Volume[i+j]*dCurrentTP;
         else
           {
            if(dCurrentTP<dPreviousTP)
                dNegativeMF+=Volume[i+j]*dCurrentTP;
           }
          dCurrentTP=dPreviousTP;      
        }
      //----
      if(dNegativeMF!=0.0)      
         ExtMFIBuffer[i]=100-100/(1+dPositiveMF/dNegativeMF);
      else
         ExtMFIBuffer[i]=100;
      //----
      
    diff = ExtMFIBuffer[i] ;  
      
    if( diff > maxdiff ) { maxdiff = diff ; maxbar = i ;}
    if( diff < mindiff && diff > 0) { mindiff = diff ; minbar = i ;}
    
    if( diff >= iMaxThreshold ) { MaxThresholdCount = MaxThresholdCount + 1 ;}
    if( diff <= iMinThreshold ) { MinThresholdCount = MinThresholdCount + 1 ;}
 

    ExtMapBuffer2[i] = maxdiff ;
    ExtMapBuffer3[i] = mindiff ;
      
      i--;
     }

   

if(Show.Commemt )
{

maxpct = (100.0 * MaxThresholdCount) / BarsInStudy ;

minpct = (100.0 * MinThresholdCount) / BarsInStudy ;

Comment("\n", 
 
"MFI(" + ExtMFIPeriod  + ")= ", DoubleToStr( diff , 2), "\n",    
"Bars In Study  = ", BarsInStudy  , "\n",  

"MAX MFI = ", DoubleToStr( maxdiff , 2),  "\n",   
"MAX BAR# = ", maxbar ,  " | " ,DoubleToStr( maxpct , 2),  "%\n",    
"MAX Threshold ",iMaxThreshold ," Exceeded ", MaxThresholdCount  ," times" ,  "\n",   
"MIN MFI = ", DoubleToStr( mindiff , 2), "\n",    
"MIN BAR# = ", minbar , " | " ,DoubleToStr( minpct , 2),  "%\n",    
"MIN Threshold ",iMinThreshold ," Exceeded ",  MinThresholdCount ," times" , "\n",    
"") ;    
   
}// if

   return(0);
}

//+------------------------------------------------------------------+  
   