//+------------------------------------------------------------------+
//|MOM_TRO_MODIFIED_VERSION                     Money Flow Index.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
//| _TRO_MODIFIED_VERSION                                  |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+
 
 
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window

 
#property indicator_buffers 3
 
extern bool   Show.Comment   = true ;

//---- input parameters
extern int ExtMOMPeriod  =14; 
extern int iNumBars      = 0 ;
extern int iMaxThreshold = 101 ;
extern int iMinThreshold = 99 ;

//---- buffers
double ExtMOMBuffer[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];

double minpips = 99999, maxpips = -99999 , spread, diff, maxdiff=-999, mindiff=999;

string  sSpread, sOpen, sPrice, sHigh, sLow, sPct, sMinDateTime, sMaxDateTime ; 
int      cd, cd1, cd2, BarsBack1, BarsBack2, minbar, maxbar ;


string symbol, tChartPeriod,  tShortName, trademsg ;   
  
int    digits2, digits, period, win, xInc, yInc, xPos, yPos  ;  
 
double    point , maxpct, minpct ;
int MaxThresholdCount = 0 ;
int MinThresholdCount = 0, BarsInStudy ;
  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
   period       =  Period() ;    
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ; 
  
   string sShortName;
//----
   SetIndexBuffer(0,ExtMOMBuffer);
//---- indicator line
   SetIndexStyle(0,DRAW_LINE, 0, 1, Blue );
//---- name for DataWindow and indicator subwindow label
   sShortName="MOM("+ExtMOMPeriod+")";
   IndicatorShortName(sShortName);
   SetIndexLabel(0,sShortName);
//---- first values aren't drawn
   SetIndexDrawBegin(0,ExtMOMPeriod);
//----
   
   SetIndexBuffer( 1, ExtMapBuffer2 );
   SetIndexBuffer( 2, ExtMapBuffer3 );
 
   SetIndexStyle( 1, DRAW_LINE, 0, 1, Green );
   SetIndexStyle( 2, DRAW_LINE, 0, 1, Red );
 


   SetLevelStyle(STYLE_DOT, 1, DimGray) ;
   SetLevelValue(1,95 );
   SetLevelValue(2,90 );   
   SetLevelValue(3,80 );
   SetLevelValue(4,50);
   SetLevelValue(5,20 );
   SetLevelValue(6,10 );
   SetLevelValue(7,5 ); 
    
   deinit() ;
   
   return(0);
  }
//+--------- TRO MODIFICATION ---------------------------------------+ 

int deinit()
{
   if(Show.Comment) {Comment("") ;}

   TRO() ;
}
//+------------------------------------------------------------------+
int start()
  {
   int    i,j,nCountedBars,LIMIT;
   double dPositiveMF,dNegativeMF,dCurrentTP,dPreviousTP;
//---- insufficient data
   if(Bars<=ExtMOMPeriod) return(0);
//---- bars count that does not changed after last indicator launch.
   nCountedBars=IndicatorCounted();
//----
   LIMIT=Bars-ExtMOMPeriod-1;


maxdiff = -9999 ;
mindiff = 99999 ;      

MaxThresholdCount = 0 ;
MinThresholdCount = 0 ;
      
     
   if( iNumBars > 0 ) { LIMIT = iNumBars ; }  
    
   BarsInStudy =  LIMIT ; 
      
   for( i = LIMIT; i >= 0 ; i-- )
   {
    ExtMOMBuffer[i] = iMomentum( symbol,period   ,ExtMOMPeriod, PRICE_CLOSE,i) ;

    diff = ExtMOMBuffer[i] ;  
      
    if( diff > maxdiff ) { maxdiff = diff ; maxbar = i ;}
    if( diff < mindiff && diff > 0) { mindiff = diff ; minbar = i ;}
    
    if( diff >= iMaxThreshold ) { MaxThresholdCount = MaxThresholdCount + 1 ;}
    if( diff <= iMinThreshold ) { MinThresholdCount = MinThresholdCount + 1 ;}
 

    ExtMapBuffer2[i] = maxdiff ;
    ExtMapBuffer3[i] = mindiff ;
  
   }

   

if(Show.Comment  )
{

maxpct = (100.0 * MaxThresholdCount) / BarsInStudy ;

minpct = (100.0 * MinThresholdCount) / BarsInStudy ;

Comment("\n", 
 
"MOM(" + ExtMOMPeriod  + ")= ", DoubleToStr( diff , 2), "\n",    
"Bars In Study  = ", BarsInStudy  , "\n",  

"MAX MOM = ", DoubleToStr( maxdiff , 2),  "\n",   
"MAX BAR# = ", maxbar ,  " | " ,DoubleToStr( maxpct , 2),  "%\n",    
"MAX Threshold ",iMaxThreshold ," Exceeded ", MaxThresholdCount  ," times" ,  "\n",   
"MIN MOM = ", DoubleToStr( mindiff , 2), "\n",    
"MIN BAR# = ", minbar , " | " ,DoubleToStr( minpct , 2),  "%\n",    
"MIN Threshold ",iMinThreshold ," Exceeded ",  MinThresholdCount ," times" , "\n",    
"") ;    
   
}// if

   return(0);
}
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}


//+------------------------------------------------------------------+ 
 